package org.maachang.mimdb.core.util ;

/**
 * オブジェクトKeyValue.
 * このオブジェクトはNULL禁止です.
 * 
 * @version 2013/10/29
 * @author masahito suzuki
 * @since MasterInMemDB 1.00
 */
@SuppressWarnings("unchecked")
public final class NNObjectKeyValue<K,V> {
    private static final int DEF_LENGTH = 32 ;
    
    private static final class NNObjectKeyValueChild {
        Object b ;
        Object o ;
        NNObjectKeyValueChild n ;
        NNObjectKeyValueChild( Object k,Object v ) {
            b = k ; o = v ;
        }
    }
    
    private NNObjectKeyValueChild[] list ;
    private int mask ;
    private int length ;
    private int limit ;
    private int base ;
    
    /**
     * コンストラクタ.
     */
    public NNObjectKeyValue() {
        this( DEF_LENGTH ) ;
    }
    
    /**
     * コンストラクタ.
     * @param size 初期サイズを設定します.この条件は２の倍数である必要があります.
     */
    public NNObjectKeyValue( int size ) {
        if( size <= DEF_LENGTH ) {
            size = DEF_LENGTH ;
        }
        else {
            size = NumberKeySet.bitMask( size ) ;
        }
        list = new NNObjectKeyValueChild[ size ] ;
        length = 0 ;
        mask = size - 1 ;
        limit = size ;
        base = size ;
    }
    
    /**
     * クリア.
     */
    public void clear() {
        list = new NNObjectKeyValueChild[ base ] ;
        length = 0 ;
        mask = base - 1 ;
        limit = base ;
    }
    
    /**
     * 数値追加.
     * @param b 対象の数値を設定します.
     * @param o 対象の要素を設定します.
     */
    public void put( K b,V o ) {
        if( b == null ) {
            throw new RuntimeException( "このオブジェクトはNULL禁止です" ) ;
        }
        int h,bh ;
        if( length + 1 >= limit ) {
            int nLen = limit << 1 ;
            int msk = nLen - 1 ;
            NNObjectKeyValueChild[] nList = new NNObjectKeyValueChild[ nLen ] ;
            NNObjectKeyValueChild n,t ;
            for( int i = 0 ; i < limit ; i ++ ) {
                n = list[ i ] ;
                while( n != null ) {
                    if( nList[ ( h = n.b.hashCode() & msk ) ] == null ) {
                        t = n.n ;
                        n.n = null ;
                    }
                    else {
                        t = n.n ;
                        n.n = nList[ h ] ;
                    }
                    nList[ h ] = n ;
                    n = t ;
                }
            }
            list = nList ;
            limit = nLen ;
            mask = msk ;
        }
        if( list[ ( h = b.hashCode() & mask ) ] == null ) {
            list[ h ] = new NNObjectKeyValueChild( b,o ) ;
            length ++ ;
        }
        else {
            bh = b.hashCode() ;
            NNObjectKeyValueChild nn = list[ h ] ;
            while( nn.n != null ) {
                if( nn.b.hashCode() == bh && ( nn.b == b || nn.b.equals( b ) ) ) {
                    nn.o = o ;
                    return ;
                }
                nn = nn.n ;
            }
            if( nn.b.hashCode() == bh && ( nn.b == b || nn.b.equals( b ) ) ) {
                nn.o = o ;
            }
            else {
                nn.n = new NNObjectKeyValueChild( b,o ) ;
                length ++ ;
            }
        }
    }
    
    /**
     * 情報が存在するかチェック.
     * @param b 対象のキーを設定します.
     * @return boolean [true]の場合、数値は存在します.
     */
    public boolean containsKey( K b ) {
        if( b == null ) {
            return false ;
        }
        int hb = b.hashCode() ;
        NNObjectKeyValueChild n = list[ hb & mask ] ;
        while( n != null ) {
            if( n.b.hashCode() == hb && ( n.b == b || n.b.equals( b ) ) ) {
                return true ;
            }
            n = n.n ;
        }
        return false ;
    }
    
    /**
     * 情報が存在するかチェック.
     * @param b 対象のキーを設定します.
     * @return Object 要素情報が返却されます.
     */
    public V get( K b ) {
        if( b == null ) {
            return null ;
        }
        int hb = b.hashCode() ;
        NNObjectKeyValueChild n = list[ hb & mask ] ;
        while( n != null ) {
            if( n.b.hashCode() == hb && ( n.b == b || n.b.equals( b ) ) ) {
                return (V)n.o ;
            }
            n = n.n ;
        }
        return null ;
    }
    
    /**
     * 削除処理.
     * @param b 対象のキーを設定します.
     */
    public void remove( Object b ) {
        if( b == null ) {
            return ;
        }
        int bh = b.hashCode() ;
        NNObjectKeyValueChild bf = null ;
        NNObjectKeyValueChild n = list[ bh & mask ] ;
        while( n != null ) {
            if( n.b.hashCode() == bh && ( n.b == b || n.b.equals( b ) ) ) {
                if( bf == null ) {
                    if( n.n == null ) {
                        list[ bh & mask ] = null ;
                    }
                    else {
                        list[ bh & mask ] = n.n ;
                    }
                }
                else {
                    if( n.n == null ) {
                        bf.n = null ;
                    }
                    else {
                        bf.n = n.n ;
                    }
                }
                length -- ;
                break ;
            }
            bf = n ;
            n = n.n ;
        }
    }
    
    /**
     * サイズを取得.
     * @return int サイズが返却されます.
     */
    public int size() {
        return length ;
    }
    
    /**
     * 配列として返却.
     * @return Object[] 配列として返却します.
     */
    public Object[] keyArray() {
        if( size() == 0 ) {
            return null ;
        }
        NNObjectKeyValueChild n ;
        int cnt ;
        Object[] ret ;
        ret = new Object[ length ] ;
        cnt = 0 ;
        for( int i = 0 ; i < limit ; i ++ ) {
            if( list[ i ] != null ) {
                n = list[ i ] ;
                while( n != null ) {
                    ret[ cnt ++ ] = n.b ;
                    n = n.n ;
                }
            }
        }
        return ret ;
    }
    
    /** 位置読み込み条件. **/
    private int pos = 0 ;
    private NNObjectKeyValueChild cPos = null ;
    private int count = 0 ;
    
    /**
     * 読み込み中の位置をリセット.
     * @return NNObjectKeyValue このオブジェクトが返却されます.
     */
    public NNObjectKeyValue<K,V> reset() {
        pos = 0 ;
        cPos = null ;
        count = 0 ;
        return this ;
    }
    
    /**
     * 次の読み込み条件を取得.
     * @return boolean [true]が返却された場合、情報は存在します.
     */
    public boolean hasNext() {
        if( cPos != null ) {
            if( ( cPos = cPos.n ) != null ) {
                count ++ ;
                return true ;
            }
        }
        while( pos < limit ) {
            if( ( cPos = list[ pos ++ ] ) != null ) {
                count ++ ;
                return true ;
            }
        }
        return false ;
    }
    
    /**
     * 現在の読み込み位置のキー情報を取得.
     * @return Object 現在の読み込み位置の内容が返却されます.
     *                 [null]の場合は、情報は存在しません.
     */
    public K next() {
        if( cPos == null ) {
            return null ;
        }
        return (K)cPos.b ;
    }
    
    /*
     * 現在の読み込み位置の要素情報を取得.
     * @return Object 現在の読み込み位置の内容が返却されます.
     */
    public V nextValue() {
        if( cPos == null ) {
            return null ;
        }
        return (V)cPos.o ;
    }
    
    /**
     * カウントを取得.
     * @return int 現在読み込み中の位置が返却されます.
     */
    public int count() {
        return count ;
    }
}
